<?

$certFile = "./openssl/crypto/cacerts/cacert.pem";
$keyFile = "./openssl/crypto/keys/cakey.pem";

$configFile = "./config/configuration.php";

include_once($configFile);

$passPhrase = $config['passPhrase'];

if ($_REQUEST['pass'] != $passPhrase) {
	print "<h1>Renovar certificado de AC-UPCT</h1><p><b>Contrasea incorrecta</b><br/>No introdujo la contrasea correctamente";
	return;
}

?>
<h1>Solicitud de firma de certificado</h1>

<p>
Vamos a firmar la solicitud del certificado suminstrado con las claves de la AC. Despus se devolver el certificado firmado.
</p>

<p>
Firmando el certificado... Por favor espere...
</p>

<?
// Ahora vamos a crear nuestro certificado de AC
$errorCount = 0;

print "<b>Cargando clave de la AC...</b><br/>";
flush();
$fp = fopen($keyFile, "r") or $errorCount++;
$myKey = fread($fp, filesize($keyFile)) or $errorCount++;
fclose($fp) or $errorCount++;
if ($errorCount) {
	print "ERROR FATAL: Ha ocurrido un error en el script. Posiblemente debido a los permisos de archivos inadecuados.";

}
print "Hecho<br/><br/>\n";

print "<b>Decodificando clave de AC...</b><br/>";
flush();
$privkey = openssl_pkey_get_private($myKey, $passPhrase);
checkError($privkey);
print "Hecho<br/><br/>\n";

print "<b>Cargando certificado AC...</b><br/>";
flush();
$fp = fopen($certFile, "r") or $errorCount++;
$myCert = fread($fp, filesize($certFile)) or $errorCount++;
fclose($fp) or $errorCount++;
if ($errorCount) {
	print "ERROR FATAL: Ha ocurrido un error en el script. Posiblemente debido a los permisos de archivos inadecuados.";

}
print "Hecho<br/><br/>\n";

print "<b>Firmando solicitud de firma de certificado...</b><br/>";

$csr = "";
$csrFile = "";
if ($_REQUEST['name'])
	$csrFile = "./openssl/crypto/requests/".substr(preg_replace('/[^a-z0-9\.]+/', '_', $_REQUEST['name']),0,30).".csr";

if ($_REQUEST['request']) {
	$csr = $_REQUEST['request'];
	if ($csrFile) {
		$fp = fopen($csrFile, "w");
		fputs($fp, $csr);
		fclose($fp);
	}
}

elseif ($csrFile && is_file($csrFile)) {
	$fp = fopen($csrFile, "r");
	$csr = fread($fp, filesize($csrFile));
	fclose($fp);
}
else {
	print "<b>Error: </b> No se puede leer la solicitud de firma de certificado del disco \"$csrFile\", y no se ha proporcionado en la solicitud.";
	return;
}

checkError($csr);

print "<pre>$csr</pre><br/>";
flush();
$scert = openssl_csr_sign($csr, $myCert, $privkey, 365*5, $config, getSerial());
flush();

checkError($scert);
print "Hecho<br/><br/>\n";

print "<b>Exportando Certificado X509...</b><br/>";
flush();
checkError(openssl_x509_export($scert, $theirCert));
print "Hecho<br/><br/>\n";

print "<b>Su certificado:</b>\n<pre>$theirCert</pre>\n";

?>
<h1>Solicitud de certificado firmada con xito con la clave de la AC.</h1>

