<?

$certFile = "./openssl/crypto/cacerts/cacert.pem";
$keyFile = "./openssl/crypto/keys/cakey.pem";

$configFile = "./config/configuration.php";

include_once($configFile);

$dn['commonName'] = $config['orgName'] . " Certificate Authority";
$dn['organizationName'] = $config['orgName'];
$dn['organizationalUnitName'] = $config['orgName'] . " Certification";
$dn['emailAddress'] = $config['contact'];
$dn['localityName'] = $config['city'];
$dn['stateOrProvinceName'] = $config['state'];
$dn['countryName'] = $config['country'];

$passPhrase = $config['passPhrase'];

if ($_REQUEST['pass'] != $passPhrase) {
	print "<h1>Renovar certificado de AC-UPCT</h1><p><b>Contrasea incorrecta</b><br/>No introdujo la contrasea correctamente";
	print "--&gt; <a href=\"index.php?area=admin\">Intntelo de nuevo</a><br/>\n";
	return;
}

?>
<h1>Renovar certificado de AC-UPCT</h1>

<p>
Se editar el certificado de la AC inicial. Este software usar el par de claves (clave pblica y privada), y despus se firmar su propio par de claves, crendose as un certificado autofirmado.
</p>

<p>
Creando mi certificado autofirmado...Por favor espere...
</p>
<?
// Ahora crearemos nuestro certificado de AC.
$errorCount = 0;

print "<b>Comprobando sus datos...</b><br/>";
print "<pre>DN = ".var_export($dn,1)."</pre>";

print "<b>Cargando clave actual...</b><br/>";
$fp = fopen($keyFile, "r") or $errorCount++;
$myKey = fread($fp, filesize($keyFile)) or $errorCount++;
fclose($fp) or $errorCount++;
if ($errorCount) {
	print "ERROR FATAL: ha ocurrido un error en el script. Posiblemente debido a permisos inadecuados de los archivos.";
	exit();
}
print "Hecho<br/><br/>\n";

print "<b>Decodificando clave actual...</b><br/>";
$privkey = openssl_pkey_get_private($myKey, $passPhrase);
checkError($privkey);
print "Hecho<br/><br/>\n";

print "<b>Creando Solicitud de Firma de Certificado (CSR)...</b><br/>";

var_export($dn);
$csr = openssl_csr_new($dn, $privkey);
checkError($csr);
print "Hecho<br/><br/>\n";

print "<b>Autofirmando CSR...</b><br/>";
$sscert = openssl_csr_sign($csr, null, $privkey, 365 * 5, array(), getSerial()); // 5 years
checkError($sscert);
print "Hecho<br/><br/>\n";

print "<b>Exportando certificado X509...</b><br/>";
checkError(openssl_x509_export($sscert, $myCert));
print "Hecho<br/><br/>\n";

print "<b>Guardando su certificado...</b><br/>";
if ($fp = fopen($certFile, 'w')) {
	fputs($fp, $myCert) or $errorCount++;
	fclose($fp) or $errorCount++;
}
else $errorCount++;
if ($errorCount) {
	print "ERROR FATAL: ha ocurrido un error en el script. Posiblemente debido a permisos inadecuados de los archivos.";
	exit();
}
print "Hecho<br/><br/>\n";

print "<b>Su certificado:</b>\n<pre>$myCert</pre>\n";
print "<b>Su clave:</b>\n<pre>$myKey</pre>\n";

?>
<h1>Renovacin del certificado AC de manera satisfactoria.</h1>
<p>
Si desea instalar esta Autoridad Certificadora como un servidor de confianza:<br/>
--&gt; <a href="index.php?area=main&stage=trust"> AC </a>
</p>


