<?

$certFile = "./openssl/crypto/cacerts/cacert.pem";
$keyFile = "./openssl/crypto/keys/cakey.pem";
$certFileClient = "./openssl/crypto/certs/certClient.p12";
$keyFileClient ="./openssl/crypto/certs/keyClient.key";

$configFile = "./config/configuration.php";
$passFile ="./config/password.txt";

include_once($configFile);

$dn['commonName'] = $config['orgName'] . " Certificate Authority";
$dn['organizationName'] = $config['orgName'];
$dn['organizationalUnitName'] = $config['orgName'] . " Certification";
$dn['emailAddress'] = $config['contact'];
$dn['localityName'] = $config['city'];
$dn['stateOrProvinceName'] = $config['state'];
$dn['countryName'] = $config['country'];

$passPhrase = $config['passPhrase'];

if($fp = fopen($passFile,"r")){
	$claveFich = fread($fp,filesize($passFile));
	fclose($fp);
}


if ($_REQUEST['clave'] != $claveFich) {
	print "<h1>Renovar certificado Cliente</h1><p><b>Contrasea incorrecta</b><br/>No introdujo la contrasea correctamente";
	print "--&gt; <a href=\"index.php?area=admin\">Intntelo de nuevo</a><br/>\n";
	return;
}

?>
<h1>Renovar certificado Cliente</h1>

<p>
Se renovar el certificado que usted obtuvo de la entidad AC-UPCT. Este software usar el par de claves que se han generado anteriormente(clave pblica y privada),y despus se volver a firmar para que usted consiga su certificado personal renovado.
</p>

<p>
Creando su certificado personal...Por favor espere...
</p>
<?
// Ahora crearemos nuestro certificado Cliente de AC-UPCT.
$errorCount = 0;

print "<b>Comprobando sus datos...</b><br/>";
print "<pre>DN = ".var_export($dn,1)."</pre>";

print "<b>Cargando certificado de la AC...</b><br/>";
if ($fp=fopen("openssl/crypto/cacerts/cacert.pem","r")) {
		$certData=fread($fp,8192);
		fclose($fp);
}
else {
		printHeader("Error");
		print "<h1>Error</h1>";
		print "Error leyendo mi certificado, compruebe los permisos<br/>\n";
		printFooter();
		return;
}
$caCert = openssl_x509_read($certData);
checkError($caCert);

print "<b>Cargando clave actual de la AC...</b><br/>";
if ($fp=fopen("openssl/crypto/keys/cakey.pem","r")) 			
{
	$privKey=fread($fp,8192);
	fclose($fp);		
}
else {
	printHeader("Error");
	print "<h1>Error</h1>";
	print "Error leyendo mi clave, compruebe los permisos<br/>\n";
	printFooter();
	return;
}

print "<b>Decodificando clave actual de la AC...</b><br/>";
$caKey = openssl_get_privatekey($privKey,$config['passPhrase']);
checkError($caKey);

print "<b>Cargando clave actual del certificado cliente...</b><br/>";
if ($fp=fopen("openssl/crypto/certs/keyClient.key","r")) 		
{
	$privKeyClient=fread($fp,filesize($keyFileClient));
	fclose($fp);		
}
else {
	printHeader("Error");
	print "<h1>Error</h1>";
	print "Error leyendo mi clave, compruebe los permisos<br/>\n";
	printFooter();
	return;
}

print "<b>Decodificando clave actual del certificado cliente...</b><br/>";
$clientKey = openssl_get_privatekey($privKeyClient,$claveFich);
checkError($clientKey);

print "<b>Creando Solicitud de Firma de Certificado (CSR)...</b><br/>";

//var_export($dn);
$csr = openssl_csr_new($_REQUEST['dn'], $privKeyClient);
checkError($csr);
print "Hecho<br/><br/>\n";

openssl_csr_export_to_file($csr,'openssl/crypto/requests/solicitudcertRe.csr',FALSE);

print "<b>Autofirmando CSR...</b><br/>";
$signedCert = openssl_csr_sign($csr, $caCert, $caKey, 365*2, $config, getSerial());
checkError($signedCert);
print "Hecho<br/><br/>\n";

print "<b>Exportando certificado pk12...</b><br/>";
$cert12=openssl_pkcs12_export($signedCert,$certout,$privKeyClient,$claveFich);
checkError($cert12);

print "Hecho<br/><br/>\n";

print "<b>Guardando su certificado cliente...</b><br/>";
if ($fp = fopen($certFileClient, 'w')) {
	fputs($fp, $certout);
	fclose($fp);
}
else {
	printHeader("Error");
	print "<h1>Error</h1>";
	print "Error leyendo mi clave, compruebe los permisos<br/>\n";
	printFooter();
	return;
}
print "Su certificado de cliente est preparado. Por favor <a href=\"./openssl/crypto/certs/certClient.p12\">Instlelo ahora</a>; Nota: su navegador est instalando el certificado.";

?>
<h1>Renovacin del certificado cliente de manera satisfactoria.</h1>

