<?


$certFile = "./openssl/crypto/cacerts/cacert.pem";
$keyFile = "./openssl/crypto/keys/cakey.pem";
$indexFile = "./openssl/crypto/index.txt";
$serialFile = "./openssl/crypto/serial";
$configFile = "./config/configuration.php";

$folders = array(
	'openssl/crypto',
	'openssl/crypto/keys',
	'openssl/crypto/cacerts',
);
foreach ($folders as $pos=>$folder) {
	if (file_exists($folder)) {
		if (!is_dir($folder)) {
			print "Error, $folder est ya creado, por favor brrelo<br/>\n";
			return;
		}
		if (!touch("$folder/test")) {
			print "Error, $folder parece tener permisos insuficientes del usuario actual para escribir.<br/>\n";
			return;
		}
		unlink("$folder/test");
	}
	else {
		mkdir($folder);
		if (!is_dir($folder)) {
			print "Imposible crear $folder, por favor compruebe los permisos<br/>\n";
			return;
		}
	}
}

if (get_magic_quotes_gpc()) {
	$passPhrase = stripslashes($_REQUEST['passPhrase']);
	while (list($key, $val) = each($_REQUEST['dn'])) {
		$dn[$key] = stripslashes($val);
	}
}
else {
	$passPhrase = &$_REQUEST['passPhrase'];
    $dn = &$_REQUEST['dn'];
}

?>
<h1>Creando Autoridad Certificadora UPCT incial </h1>

<p>
Este es el punto donde se generar el certificado de la Autoridad Certificadora de la UPCT. Este software generar un par de claves (una clave pblica y una clave privada correspondiente), despus se firma el par de claves, lo que crea un certificado autofirmado.
</p>

<p>
Creando mi propio certificado autofirmado...Por favor espere...
</p>

<?
// Ahora es el momento de crearnos un certificado AC.
$errorCount = 0;

print "<b>Comprobando sus datos...</b><br/>";

print "<pre>DN = ".var_export($_REQUEST['dn'],1)."</pre>";

print "<b>Generando nueva clave...</b><br/>";
$privkey = openssl_pkey_new($config);
checkError($privkey);
print "Hecho<br/><br/>\n";

print "<b>Creando Solicitud de Firma de Certificado (CSR)...</b><br/>";
$csr = openssl_csr_new($_REQUEST['dn'], $privkey);

/**/
openssl_csr_export_to_file($csr,'openssl/crypto/requests/solicitud.csr',FALSE);
/**/

checkError($csr);
print "Hecho<br/><br/>\n";

print "<b>Auto firmando CSR...</b><br/>";
$sscert = openssl_csr_sign($csr, null, $privkey, 3650, array(), getSerial());
checkError($sscert);
print "Hecho<br/><br/>\n";

print "<b>Exportando certificado X509...</b><br/>";
checkError(openssl_x509_export($sscert, $myCert));
print "Hecho<br/><br/>\n";

print "<b>Exportando clave privada codificada...</b><br/>";
checkError(openssl_pkey_export($privkey, $myKey, $passPhrase));
print "Hecho<br/><br/>\n";

print "<b>Guardando su certificado...</b><br/>";
if ($fp = fopen($certFile, 'w')) {
	fputs($fp, $myCert) or $errorCount++;
	fclose($fp) or $errorCount++;
}
else $errorCount++;

if ($errorCount) {
	print "ERROR FATAL: ha ocurrido un error en el script. Posiblemente debido a permisos inadecuados de los archivos.";
	exit();
}

print "Hecho<br/><br/>\n";

print "<b>Guardando su clave codificada...</b><br/>";
if ($fp = fopen($keyFile, 'w')) {
	fputs($fp, $myKey) or $errorCount++;
	fclose($fp) or $errorCount++;
}
else $errorCount++;
if ($errorCount) {
	print "ERROR FATAL: ha ocurrido un error en el script. Posiblemente debido a permisos inadecuados de los archivos.";
	exit();
}
print "Hecho<br/><br/>\n";

$date = date("Y-m-d H:i:s (Z)");
$quotedPassPhrase = addslashes($passPhrase);
$quotedOrganization = addslashes($dn['organizationName']);
$quotedContact = addslashes($dn['emailAddress']);
$quotedCity = addslashes($dn['localityName']);
$quotedState = addslashes($dn['stateOrProvinceName']);
$quotedCountry = addslashes($dn['countryName']);

$myConfig = <<<ENDE
<?
// Archivo de configuracion generado localmente $date
//

\$caSetup = true;
\$config['passPhrase'] = "$quotedPassPhrase";
\$config['orgName'] = "$quotedOrganization";
\$config['contact'] = "$quotedContact";
\$config['city'] = "$quotedCity";
\$config['state'] = "$quotedState";
\$config['country'] = "$quotedCountry";


ENDE;
$myConfig .= '?'.'>';

print "<b>Guardando su archivo de ndice...</b><br/>";
if ($fp = fopen($indexFile, 'w')) {
	fputs($fp, '');
	fclose($fp) or $errorCount++;
} else $errorCount++;
if ($errorCount) {
	print "ERROR FATAL: ha ocurrido un error en el script. Posiblemente debido a permisos inadecuados de los archivos.";
	exit();
}
print "Hecho<br/><br/>\n";

print "<b>Guardando su archivo serial...</b><br/>";
if ($fp = fopen($serialFile, 'w')) {
	fputs($fp, '0101') or $errorCount++;
	fclose($fp) or $errorCount++;
}
else $errorCount++;
if ($errorCount) {
	print "ERROR FATAL: ha ocurrido un error en el script. Posiblemente debido a permisos inadecuados de los archivos.";
	exit();
}
print "Hecho<br/><br/>\n";

print "<b>Guardando su archivo de configuracin...</b><br/>";
if ($fp = fopen($configFile, 'w')) {
	fputs($fp, $myConfig) or $errorCount++;
	fclose($fp) or $errorCount++;
}
else $errorCount++;
if ($errorCount) {
	print "ERROR FATAL: ha ocurrido un error en el script. Posiblemente debido a permisos inadecuados de los archivos.";
	exit();
}
print "Hecho<br/><br/>\n";

print "<b>Su certificado:</b>\n<pre>$myCert</pre>\n";
print "<b>Su clave:</b>\n<pre>$myKey</pre>\n";

?>
<h1>Se ha creado satisfactoriamente su Autoridad Certificadora UPCT y su clave.</h1>

<p>
Enhorabuena, ha creado su Autoridad Certificadora, y ahora este software est activo.
</p>

<p>
El siguiente paso que debera hacer es crear su propio certificado personal.<br/>
--&gt; <a href="index.php">Consiga su certificado firmado</a>
</p>
